<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Chapter 15: User-Defined Data Structures</title>
<link href="top.html" rev=precedes>
<link href="sx1a.html" rel=precedes>
<link href="top.html" rev=subdocument>
</head>
<body>
<H1>Chapter 15: User-Defined Data Structures</H1>

<p>So far, we have been using C's basic types--<TT>char</TT>,
<TT>int</TT>, <TT>long int</TT>, <TT>double</TT>,
etc.--and a few <dfn>derived</dfn>
types--arrays of basic types,
pointers to basic types,
and functions returning basic types.
In this chapter, we'll learn about another way to derive types:
by building user-defined types.
</p><p>There's an old joke about
Henry Ford saying that
you could get the Model T in any color you wanted,
as long as it was black.
User-defined data types have a little bit of the same restriction:
you don't have ultimate flexibility;
you can define your own data types any way you want,
as long as they're collections of other types.
(What you couldn't define would be data types that held, say,
tractors or teddy bears or Model T Fords,
because of course computers have no way of holding those objects.
You're ultimately restricted to the primitive types of data
which computers can represent,
and C's basic types cover most of those.)
</p><p>Very roughly speaking,
a structure is a little bit like an array.
An array is a collection of associated values, all of the same type.
A structure is a collection of associated values,
but the values can all have different types.
</p><p><a href="sx1a.html" rel=subdocument>15.1: Structures</a></p>
<p><a href="sx1b.html" rel=subdocument>15.2: Accessing Members of Structures</a></p>
<p><a href="sx1c.html" rel=subdocument>15.3: Operations on Structures</a></p>
<p><a href="sx1d.html" rel=subdocument>15.4: Pointers to Structures</a></p>
<p><a href="sx1e.html" rel=subdocument>15.5: Linked Data Structures</a></p>
<hr>
<p>
Read sequentially:
<a href="top.html" rev=precedes>prev</a>
<a href="sx1a.html" rel=precedes>next</a>
<a href="top.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1996-1999
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
